package com.eactive.eai.batch.job.jobItem.lgcns;

import java.io.ByteArrayOutputStream;
import java.io.File;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.batch.common.CommonKeys;
import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_LGCNS_0630 extends DefaultTelegram implements TelegramService
{
    private int SEND_LENGTH;       //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이

    /**
     * 생성자
     */
    public SEND_LGCNS_0630() {
        //화일정보수신요구
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {

            boolean result = calculateSendLength();
            if (!result) return false;

            int seqSize = ( batchDoc.getBatchMsg().getHeader().getSequenceSize() / batchDoc.getBatchMsg().getHeader().getRecLen() ) * batchDoc.getBatchMsg().getHeader().getRecLen();

            //전송길이
            compileField(0, "" + SEND_LENGTH, this.al_FieldProps[0]);

            //트랜잭션코드 -- 사용하지 않음
            compileField(1, "", this.al_FieldProps[1]);

            //업무구분코드 - “CMS”
            compileField(2, "CMS", this.al_FieldProps[2]);

            //기관코드 “71”
            compileField(3, "71", this.al_FieldProps[3]);

            //전문종별코드. 전문의 기능을 나타냄.
            compileField(4, this.getFldTelegramType(), this.al_FieldProps[4]);

            //거래구분코드 S/R :  서버송신 : S 서버수신: R
            String procType = batchDoc.getBatchMsg().getHeader().getProcessType();
            if ( procType.equalsIgnoreCase(CommonKeys.PROCESS_REQUEST_SEND)) {
                compileField(5, "R", this.al_FieldProps[5]);
            }else{
                compileField(5, "S", this.al_FieldProps[5]);
            }

            //송수신 FLAG B/C    B:Bank, C:Center
            compileField(6, "B", this.al_FieldProps[6]);

            //화일명
        	String fileName = batchDoc.getBatchMsg().getHeader().getFileName();
        	if ( fileName.indexOf("_") > -1 ){
        		fileName = fileName.substring(0, fileName.indexOf("_"));
        	}
            compileField(7, fileName , this.al_FieldProps[7]);

            //응답코드
            compileField(8, TelegramKeys.RPS_HDB_RET_CODE_SUCCESS, this.al_FieldProps[8]);
            //화일 정보내역. 화일명+화일size+전문바이트수
            //RECV 0630/0640에서는 서로 교환한 값중 작은 값으로 결정한다.
            StringBuffer fileInfo = new StringBuffer();
            fileInfo.append(makeSpace(fileName, 20));
            fileInfo.append(makeZero(""+batchDoc.getBatchMsg().getHeader().getFileSize(), 12));
            // 0630 전문 길이 ( 공통 + 24  = SEND_LENGTH ) 0320 전문 길이 ( 공통 + 11 + 파일내역  )
            // 그러므로 0320 전문의 길이는 0630 전문 길이에서 파일 내역을 더하고 13을 빼 준다 )
            fileInfo.append(makeZero(""+(SEND_LENGTH  + seqSize - 13), 4));

            compileField(9, fileInfo.toString(), this.al_FieldProps[9]);
            
            //상대ID
            compileField(10, fileName, this.al_FieldProps[10]);

            //상대ID
            compileField(11, makeZero(""+batchDoc.getBatchMsg().getHeader().getFileSize(), 12), this.al_FieldProps[11]);

            //<< 전문 완성
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            batchDoc.getBatchMsg().getHeader().setFileSize(getFileSize ());
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<9; i++) { //CMS전문의 헤더는 응답코드까지 임.
                byte[] barr = (byte[])this.al_Field.get(i);
                if ( barr[0] != '\0') {
                    baout.write((byte[])this.al_Field.get(i));
                }
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=9; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    private boolean calculateSendLength () {
        try {
            // XX인 경우 길이를 1로 계산하므로 i=3 인 경우 실제 기관 코드 사용 길이-1 만큼을 더 해 준다.
            for (int i=1; i< this.al_Field.size(); i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            REAL_SEND_LENGTH = SEND_LENGTH + ((byte[]) this.al_Field.get(0)).length;

        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    private long getFileSize ()
    {

        try {
            String fileDir = batchDoc.getBatchMsg().getHeader().getFilePath();
            String fileNm  = batchDoc.getBatchMsg().getHeader().getRenamedFileName();

            if (fileDir.charAt(fileDir.length()-1) != File.separatorChar) {
                fileDir = fileDir + File.separator;
            }

            String fileName = fileDir + fileNm;

            File file = new File(fileName);
            if (!file.exists()) // 파일이 없으면 리턴 False
            {
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = fileName;
                String errCode = "BECEAIFJI022";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                throw new Exception(" the File["+fileName+"] does not exist!!!");
            }
            return file.length();
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI028";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return 0;
        }

    }
//    /**
//     * int getCalculatedLength(int idx)
//     * --------------------------------------------------------------------------------------
//     * 전달된 인덱스 idx는 비정형 필드여야 한다. 즉 필드의 길이값이 FILE_NO_LENGTH("XX") 이어야 한다.
//     * 해당 비정형 필드에 대해 실질적인 전문길이를 동적으로 계산해 낸다.
//     */
//    public int getCalculatedLength(int idx) {
//
//        if (idx >= this.getFieldCount()) {
//            Logging(DEBUG, "getCalculatedLength> parameter is bigger than field count");
//            String[] msgArgs = new String[2];
//            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
//            msgArgs[1] = ""+idx;
//            String errCode = "BECEAIFJI011";
//            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
//            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
//            return -1;
//        }
//        if (!this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
//            String[] msgArgs = new String[2];
//            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
//            msgArgs[1] = ""+idx;
//            String errCode = "BECEAIFJI012";
//            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
//            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
//            return -1;
//        }
//        int fieldLen = -1;
////        String propKey = "";
////        switch (idx) {
////
////        case 1:
////            propKey = TelegramKeys.TRCD_LEN;
////            break;
////
////        case 3:
////            propKey = TelegramKeys.ORGN_CD_LEN;
////            break;
////
////        default:
////            String[] msgArgs = new String[2];
////            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
////            msgArgs[1] = ""+idx;
////            String errCode = "BECEAIFJI012";
////            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
////            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
////            return -1;
////        }
////
////        try {
////            fieldLen = Integer.parseInt( telegramInfo.getProperty(propKey) );
////
////        } catch (Exception e) {
////            String[] msgArgs = new String[2];
////            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
////            msgArgs[1] = propKey;
////            String errCode = "BECEAIFJI012";
////            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
////            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
////            return -1;
////        }
//
//        return fieldLen;
//    }
//
//    public int getInformalFieldSendData(int idx, byte[] data) {
//        int fldLen = getCalculatedLength(idx);
//        try {
//            if (idx >= this.getFieldCount() ) {
//                Logging(DEBUG, " getInformalFieldSendData> " +idx+ " is bigger than field count");
//                String[] msgArgs = new String[2];
//                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
//                msgArgs[1] = ""+idx;
//                String errCode = "BECEAIFJI011";
//                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
//                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
//                return -1;
//            }
//            if (data.length < fldLen) {
//                Logging(DEBUG, " getInformalFieldSendData> InformalFieldSendData size is bigger than buffer size");
//                String[] msgArgs = new String[2];
//                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
//                msgArgs[1] = ""+idx;
//                String errCode = "BECEAIFJI014";
//                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
//                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
//                return -1;
//            }
////            switch (idx) {
////            case 1:
////                // TR 코드
////                System.arraycopy((telegramInfo.getProperty(TelegramKeys.TRANSACTION_CODE) + "         ").getBytes(), 0, data, 0, fldLen );
////
////                break;
////            case 3:
////                // 기관코드
////                System.arraycopy((telegramInfo.getProperty(TelegramKeys.BANK_CODE) + "          ").getBytes(), 0, data, 0, fldLen );
////
////                break;
////
////            default:
////                break;
////            }
//
//            // 로깅을 위해
//            byte[] fieldData = new byte[fldLen];
//            System.arraycopy(data, 0, fieldData, 0, fldLen);
//            this.al_Field.set( idx, fieldData);
//            return fldLen;
//        } catch (Exception ex) {
//            String[] msgArgs = new String[1];
//            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
//            String errCode = "BECEAIFJI006";
//            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
//            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
//            logger.error( ex.getMessage(), ex);
//            return -1;
//        }
//    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(4);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
        return super.getFieldValueString(5);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(8);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
        return super.getOpCode();
    }
}